//--------------------------------------------//
//                                            //
//                                            //
// Danish Game mutator v1, by [DANISH]Klaphat //
//                                            //
//                                            //
//--------------------------------------------//
class DanishGameMuts expands Mutator config;

// variabler til - trk 1 frag fra ved dd
var bool TeamDeathMatchGame;
var config int bAdjustScore;

// variabler til - LogPlayers
var config bool bLogPlayers;
var string ips[99]; //keep record of max 100 players

//------------------------------------------------------------------------------------------------------------------
// start - trk 1 frag fra ved dd, spillerens frag kan ikke g i minus, og ved TDM trkkes ogs 1 frag fra holdet, holdets frag kan heller ikke g i minus


	function PreBeginPlay()
	{
	  if(GetItemName(string(Level.Game.Class)) == "DanishTeamGame")
	    TeamDeathMatchGame = true;
	  else
	    TeamDeathMatchGame = false;

	  super.PreBeginPlay();
	}

	function ScoreKill(pawn Killer, pawn Other)
	{

	  super.ScoreKill(Killer, Other);

	  if(Other != Killer && (Other.IsA('PlayerPawn') || Other.IsA('Bot')) && (Killer.IsA('PlayerPawn') || Killer.IsA('Bot')))
	  {
	    if(Other.PlayerReplicationInfo.Score > 0.0)
	    {
	      Other.PlayerReplicationInfo.Score -= bAdjustScore;

	      if(TeamDeathMatchGame)
	        if(TeamGamePlus(Level.Game).Teams[Other.PlayerReplicationInfo.Team].Score > 0.0)
	          TeamGamePlus(Level.Game).Teams[Other.PlayerReplicationInfo.Team].Score -= bAdjustScore;
	    }
	  }
	}

// slut - trk 1 frag fra ved dd
//------------------------------------------------------------------------------------------------------------------
// start - Danish inventory replacement

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
  Super.CheckReplacement(Other, bSuperRelevant);

  if ((Other.IsA('DanishShieldBelt')) || (Other.IsA('DanishMedBox')) || (Other.IsA('DanishHealthVial')) || (Other.IsA('DanishHealthPack')) || (Other.IsA('DanishThighPads')) || (Other.IsA('DanishDamage')) || (Other.IsA('Danishinvisibility')) || (Other.IsA('DanishJumpboots')) || (Other.IsA('DanishArmor2')))
	{
	return true;
	}
  if (Other.IsA('MedBox'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishMedBox");
		return false;
	}

  if (Other.IsA('HealthVial'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishHealthVial");
		return false;
	}

  if (Other.IsA('HealthPack'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishHealthPack");
		return false;
	}

  if (Other.IsA('Armor2'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishArmor2");
		return false;
	}


  if (Other.IsA('ThighPads'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishThighPads");
		return false;
	}


  if (Other.IsA('UDamage'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishDamage");
		return false;
	}


  if (Other.IsA('UT_Invisibility'))
	{
	  ReplaceWith(Other,"DanishUTv1.Danishinvisibility");
		return false;
	}

  if (Other.IsA('UT_Jumpboots'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishJumpboots");
		return false;
	}


  if (Other.IsA('UT_ShieldBelt'))
	{
	  ReplaceWith(Other,"DanishUTv1.DanishShieldBelt");
		return false;
	}

	return true;
}
// slut - Danish inventory replacement
//------------------------------------------------------------------------------------------------------------------
// start - LogPlayers

function PostBeginPlay()
{
	if (bLogPlayers)
    {
        log("########################################");
	log("# Logging of players joining activated #");
	log("########################################");
        Enable('Tick');
    }
}

function Tick(float DeltaTime)
{
    CheckPlayerList();
}

function CheckPlayerList()
{
    local Pawn P;
    local int pLoc;
    local string ipstr;
    for(p=level.pawnlist; p!=none ; p=p.nextpawn)
	{
        if ((p!=none) && (p.IsA('PlayerPawn')))
        {
            if (!P.PlayerReplicationInfo.bIsABot)
            {
                pLoc = P.PlayerReplicationInfo.PlayerID;
                ipstr = PlayerPawn(P).GetPlayerNetworkAddress();
                if ((ips[pLoc] != ipstr) && (ipstr != "") && (!P.PlayerReplicationInfo.bIsSpectator))
                {
                    ips[pLoc] = ipstr;
                    log("##PLAYER JOIN: "$P.PlayerReplicationInfo.PlayerName$" ,IP:"$ipstr$" ,netspeed:"$PlayerPawn(P).Player.CurrentNetSpeed);
		    log("##class:"$PlayerPawn(P).Player.Class);
                }
            }
        }
    }
}

// slut - LogPlayers
//------------------------------------------------------------------------------------------------------------------
